import net.canarymod.plugin.Plugin;
import net.canarymod.logger.Logman;
import net.canarymod.Canary;
import net.canarymod.commandsys.*;
import net.canarymod.chat.MessageReceiver;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.world.blocks.BlockType;
import net.canarymod.api.world.World;

public class KreisPlugin extends Plugin implements CommandListener {
    @Override
    public boolean enable() {
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        return true;
    }

    @Override
    public void disable() {
    }

    @Command(aliases = {"kreis"},
             description = "Platziert einen Kreis mit dem angegebenen Radius ber dem Spieler",
             permissions = {""},
             toolTip = "/kreis <radius>")
    public void kreisBauen(MessageReceiver caller, String[] parameter){
        if(caller instanceof Player){
            Player spieler = (Player) caller;

            Location position = spieler.getLocation();
            World welt = spieler.getWorld();
            double xStart = position.getX();
            double zStart = position.getZ();
            position.setY(position.getY()+ 2);
            
            int r = Integer.valueOf(parameter[1]);
            
            int d = -r;
            int x = r;
            int z  = 0;
            
            while(z <= x){
                position.setZ(zStart + z);
                position.setX(xStart + x);
                welt.setBlockAt(position, BlockType.GoldBlock);
                
                position.setZ(zStart - z);
                position.setX(xStart - x);
                welt.setBlockAt(position, BlockType.GoldBlock);
                
                position.setZ(zStart + z);
                position.setX(xStart - x);
                welt.setBlockAt(position, BlockType.GoldBlock);
                
                position.setZ(zStart - z);
                position.setX(xStart + x);
                welt.setBlockAt(position, BlockType.GoldBlock);
                
                position.setZ(zStart + x);
                position.setX(xStart + z);
                welt.setBlockAt(position, BlockType.GoldBlock);

                position.setZ(zStart - x);
                position.setX(xStart - z);
                welt.setBlockAt(position, BlockType.GoldBlock);
                
                position.setZ(zStart + x);
                position.setX(xStart - z);
                welt.setBlockAt(position, BlockType.GoldBlock);

                position.setZ(zStart - x);
                position.setX(xStart + z);
                welt.setBlockAt(position, BlockType.GoldBlock);

                d = d + 2*z + 1;
                z = z + 1;

                if(d > 0){
                    d = d - 2*x + 2;
                    x = x - 1;
                }
            }
        }
        else{
            getLogman().info("Dieser Befehl kann nur von Spielern ausgefhrt werden.");
        }
    }
}