import net.canarymod.plugin.Plugin;
import net.canarymod.logger.Logman;
import net.canarymod.Canary;
import net.canarymod.commandsys.*;
import net.canarymod.chat.MessageReceiver;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.world.blocks.BlockType;
import net.canarymod.api.world.World;

public class KugelPlugin extends Plugin implements CommandListener {
    @Override
    public boolean enable() {
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        return true;
    }

    @Override
    public void disable() {
    }

    @Command(aliases = {"kugel"},
             description = "Platziert eine Kugel mit dem angegebenen Radius ber dem Spieler",
             permissions = {""},
             toolTip = "/kugel")
    public void kugelBauen(MessageReceiver caller, String[] parameter){ 
        if(caller instanceof Player){
            Player spieler = (Player) caller;
            Location position = spieler.getLocation();
            World welt = spieler.getWorld();

            int r = Integer.valueOf(parameter[1]);

            int xStart = position.getBlockX();
            int yStart = position.getBlockY() + 20;
            int zStart = position.getBlockZ();            

            for(int x = xStart - r; x <= xStart + r; x++){
                for(int y = yStart - r; y <= yStart + r; y++){
                    for(int z = zStart - r; z <= zStart + r; z++){
                        if((x-xStart)*(x-xStart)+(y-yStart)*(y-yStart)+(z-zStart)*(z-zStart) < r*r){
                            position.setX(x);
                            position.setY(y);
                            position.setZ(z);
                            welt.setBlockAt(position, BlockType.GreenStainedClay);
                        }
                    }
                }
            }
        }
        else{
            getLogman().info("Dieser Befehl kann nur von Spielern ausgefhrt werden.");
        }
    }
}