import net.canarymod.Canary;
import net.canarymod.plugin.Plugin;
import net.canarymod.plugin.PluginListener;
import net.canarymod.hook.HookHandler;
import net.canarymod.hook.entity.ProjectileHitHook;
import net.canarymod.api.entity.Arrow;
import net.canarymod.api.factory.ItemFactory;
import net.canarymod.api.inventory.Item;
import net.canarymod.api.inventory.ItemType;
import net.canarymod.api.inventory.Enchantment;
import net.canarymod.api.inventory.recipes.CraftingRecipe;
import net.canarymod.api.inventory.recipes.RecipeRow;
import net.canarymod.api.entity.living.humanoid.Player;

public class EnderbogenPlugin extends Plugin implements PluginListener{
    @Override
    public boolean enable() {
        Canary.hooks().registerListener(this, this);

        ItemFactory gegenstaende = Canary.factory().getItemFactory();
        Item faden = gegenstaende.newItem(ItemType.String);
        Item stock = gegenstaende.newItem(ItemType.Stick);
        Item enderPerle = gegenstaende.newItem(ItemType.EnderPearl);

        Item enderbogen = gegenstaende.newItem(ItemType.Bow);
        enderbogen.setDisplayName("Enderbogen");
        Enchantment verzauberung = gegenstaende.newEnchantment(Enchantment.Type.LuckOfTheSea, (short) 1);
        enderbogen.addEnchantments(verzauberung);

        Item[] zutaten = new Item[]{enderPerle, faden, stock};
        RecipeRow reihe1 = new RecipeRow("ESF", zutaten);
        RecipeRow reihe2 = new RecipeRow("SEF", zutaten);
        RecipeRow reihe3 = new RecipeRow("ESF", zutaten);
        CraftingRecipe enderbogenRezept = new CraftingRecipe(enderbogen, new RecipeRow[]{reihe1, reihe2, reihe3});
        Canary.getServer().addRecipe(enderbogenRezept);

        return true;
    }
    
    @Override
    public void disable() {
    }
    
    @HookHandler
    public void pfeilGetroffen(ProjectileHitHook ereignis){
        if(ereignis.getProjectile() instanceof Arrow){
            Arrow pfeil = (Arrow) ereignis.getProjectile();
          
            if(pfeil.getOwner().isPlayer()){
                Player spieler = (Player) pfeil.getOwner();
                    if(spieler.getItemHeld().getDisplayName().equals("Enderbogen")){
                        spieler.teleportTo(pfeil.getLocation());
                    }
            }
        }
    }
}