import net.canarymod.Canary;
import net.canarymod.LineTracer;
import net.canarymod.plugin.Plugin;
import net.canarymod.plugin.PluginListener;
import net.canarymod.hook.HookHandler;
import net.canarymod.hook.player.BlockLeftClickHook;
import net.canarymod.api.factory.ItemFactory;
import net.canarymod.api.world.blocks.Block;
import net.canarymod.api.world.blocks.BlockType;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.inventory.Item;
import net.canarymod.api.inventory.ItemType;
import net.canarymod.api.inventory.Enchantment;
import net.canarymod.api.inventory.recipes.CraftingRecipe;

public class FeuerschwertPlugin extends Plugin implements PluginListener{
    @Override
    public boolean enable() {
        Canary.hooks().registerListener(this, this);

        ItemFactory gegenstaende = Canary.factory().getItemFactory();
        Item feuerzeug = gegenstaende.newItem(ItemType.FlintAndSteel);
        Item eisenSchwert = gegenstaende.newItem(ItemType.IronSword);

        Item feuerSchwert = gegenstaende.newItem(ItemType.IronSword);
        feuerSchwert.setDisplayName("Feuer-Schwert");
        Enchantment verzauberung = gegenstaende.newEnchantment(Enchantment.Type.LuckOfTheSea, (short) 1);
        feuerSchwert.addEnchantments(verzauberung);

        CraftingRecipe feuerSchwertRezept = new CraftingRecipe(feuerSchwert, new Item[]{feuerzeug, eisenSchwert});
        Canary.getServer().addRecipe(feuerSchwertRezept);

        return true;
    }
    
    @Override
    public void disable() {
    }

    @HookHandler
    public void anzuenden(BlockLeftClickHook ereignis){
        Player spieler = ereignis.getPlayer();
        if(spieler.getItemHeld().getDisplayName().equals("Feuer-Schwert")){
            Block block = ereignis.getBlock();
            block = block.getRelative(0,1,0);
            block.setType(BlockType.FireBlock);
            block.update();
        }
    }
}