import net.canarymod.database.DataAccess;
import net.canarymod.database.Column;
import net.canarymod.database.Column.ColumnType;
import net.canarymod.database.Column.DataType;
import net.canarymod.api.world.World;
import net.canarymod.api.world.blocks.Block;
import net.canarymod.api.world.position.Position;

public class SchilderTabelle extends DataAccess {
    @Column(columnName = "nummer",
            dataType   = DataType.INTEGER,
            columnType  = Column.ColumnType.PRIMARY)
    public int nummer;

    @Column(columnName = "besitzer",
            dataType   = DataType.STRING)
    public String besitzer;

    @Column(columnName = "schild",
            dataType   = DataType.STRING)
    public String schild;

    public SchilderTabelle(int nummer, String besitzer, Block schild){
        super("schilder_tabelle");

        this. nummer = nummer;
        this.besitzer = besitzer;

        if(schild != null){
            Position position = schild.getPosition();
            this.schild = position.getBlockX() + "," + position.getBlockY() + "," + position.getBlockZ();
        }
    }

    public Block getSchild(World welt){
        String[] positionString = schild.split(",");
        
        int x = Integer.valueOf(positionString[0]);
        int y = Integer.valueOf(positionString[1]);
        int z = Integer.valueOf(positionString[2]);
        
        Position position = new Position(x, y, z);
        Block schild = welt.getBlockAt(position);
        return schild;
    }

    public DataAccess getInstance(){
        return new SchilderTabelle(-1, "", null);
    }
}