import java.util.Random;
import java.util.HashMap;

import net.canarymod.Canary;
import net.canarymod.plugin.Plugin;
import net.canarymod.plugin.PluginListener;
import net.canarymod.logger.Logman;
import net.canarymod.commandsys.Command;
import net.canarymod.commandsys.CommandListener;
import net.canarymod.chat.MessageReceiver;

import net.canarymod.hook.HookHandler;
import net.canarymod.hook.Hook;
import net.canarymod.hook.player.ConnectionHook;
import net.canarymod.hook.player.ItemPickupHook;

import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.entity.EntityType;

import net.canarymod.api.inventory.ItemType;
import net.canarymod.api.inventory.Item;


public class Sammelspiel extends Plugin implements PluginListener, CommandListener {
    private ItemType gesuchterGegenstand;
    private int anzahl;
    private HashMap<String, Integer> gesammelt;

    @Override
    public boolean enable() {
        gesammelt = new HashMap<String, Integer>();
        Canary.hooks().registerListener(this, this);
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        neueRundeStarten();
        return true; 
    }

    @Override
    public void disable(){
    }
    
    private void neueRundeStarten(){
        Random zufallsgenerator = new Random();
        
        String[] spielerListe = gesammelt.keySet().toArray(new String[gesammelt.size()]);
        
        for(int i = 0; i < spielerListe.length; i++){
            gesammelt.put(spielerListe[i], 0);
        }

        ItemType[] gegenstaende = {ItemType.Sunflower, ItemType.RedTulip, ItemType.Egg};
        gesuchterGegenstand = gegenstaende[zufallsgenerator.nextInt(gegenstaende.length)];
        anzahl = zufallsgenerator.nextInt(4)+1;
        
        Item g = Canary.factory().getItemFactory().newItem(gesuchterGegenstand);      
        Canary.instance().getServer().broadcastMessage("Neue Runde! Sammle " + anzahl + " " + g.getDisplayName() + "!");
    }
    
    @HookHandler
    public void spielerBetrittServer(ConnectionHook ereignis){
        String spielerId = ereignis.getPlayer().getUUID().toString();
        
        if(!gesammelt.containsKey(spielerId)){
            gesammelt.put(spielerId, 0);
        } 
        
        Item g = Canary.factory().getItemFactory().newItem(gesuchterGegenstand);      
        Canary.instance().getServer().broadcastMessage("Willkommen! Auf diesem Server wird das Sammelspiel gespielt. Sammle " + anzahl + " " + g.getDisplayName() + " um zu gewinnen!");            
    }
    
    @HookHandler
    public void gegenstandAufgehoben(ItemPickupHook ereignis){
        if(ereignis.getItem().getItem().getType() == gesuchterGegenstand){
            String spielerId = ereignis.getPlayer().getUUID().toString();
            int neueAnzahl = gesammelt.get(spielerId) + 1;

            if(neueAnzahl == anzahl){
                //runde gewonnen
                ereignis.getPlayer().message("Herzlichen Glckwunsch, du hast die Runde gewonnen!");
                ereignis.getPlayer().addExperience(20);
                neueRundeStarten();
            }
            else{
                //runde geht weiter           
                gesammelt.put(spielerId, neueAnzahl);
                Item g = Canary.factory().getItemFactory().newItem(gesuchterGegenstand);
                ereignis.getPlayer().message("Du musst noch " + (anzahl - gesammelt.get(spielerId)) + " " + g.getDisplayName() + " sammeln." );
            }
            
            ereignis.getItem().getItem().setId(-1);
            ereignis.getItem().setAge((short) 6000);
        }  
    }
       
    @Command(aliases = {"aufgabe"},
             description = "Zeigt die aktuelle Sammel-Aufgabe",
             permissions = {""},
             toolTip = "/aufgabe")
    public void aufgabeAnzeigen(MessageReceiver caller, String[] parameter){
        if(caller instanceof Player){
            Player spieler = caller.asPlayer();
            String spielerId = spieler.getUUID().toString();
            Item g = Canary.factory().getItemFactory().newItem(gesuchterGegenstand);
            caller.message("Du musst noch " + (anzahl - gesammelt.get(spielerId)) + " " + g.getDisplayName() + " sammeln." );
        }
    }
}