import net.canarymod.api.ai.AIBase;
import net.canarymod.api.entity.living.Golem;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.inventory.Item;

public class FolgeKI implements AIBase{
    MeinGolem golem;

    public FolgeKI(MeinGolem golem){
        this.golem = golem;
    }

    @Override
    public void updateTask(){    
        Player besitzer = this.golem.getBesitzer();
        Golem golem = this.golem.getGolem();
    
        if(golem.getMotionY() > 0){
            golem.setMotionY(0.0);
        }
        else if(golem.getMotionX() == 0 && golem.getMotionZ() == 0){
            golem.setMotionY(1.0);
      
            if(golem.getLocation().getX() - besitzer.getLocation().getX() > 0){
                golem.setMotionX(-0.2);        
            }
            else{
                golem.setMotionX(0.2);
            }
            
            if(golem.getLocation().getZ() - besitzer.getLocation().getZ() > 0){
                golem.setMotionZ(-0.2);        
            }
            else{
                golem.setMotionZ(0.2);
            }
        }
    
    golem.moveEntityToXYZ(besitzer.getLocation().getX(), besitzer.getLocation().getY(), besitzer.getLocation().getZ(), 1.0f); 
    
    double abstand = golem.getLocation().getDistance(besitzer.getLocation());
    if(abstand < 2){
        Item i = this.golem.gegenstandGeben();
            if(i != null){
                besitzer.giveItem(i);
                this.golem.gegenstandNehmen(null);
            }
        }
    }
  
    @Override
    public void resetTask(){
    }
    
    @Override
    public void startExecuting(){
    }
  
    @Override
    public boolean isContinuous(){
        return true;
    }
  
    @Override
    public boolean continueExecuting(){
        return this.golem.getFolgen();
    }
  
    @Override
    public boolean shouldExecute(){
        return this.golem.getFolgen();  
    }
}