import net.canarymod.Canary;
import net.canarymod.plugin.Plugin;
import net.canarymod.logger.Logman;
import net.canarymod.commandsys.Command;
import net.canarymod.commandsys.CommandListener;
import net.canarymod.chat.MessageReceiver;
import net.canarymod.api.entity.EntityType;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.world.blocks.BlockType;


public class GolemPlugin extends Plugin implements CommandListener{
    private MeinGolem golem = null;

    @Override
    public boolean enable() {
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        return true;
    }

    @Override
    public void disable() {
    }

    @Command(aliases = {"golem"},
             description = "Steuert deinen Golem",
             permissions = {""},
             toolTip = "/golem <befehl>",
             min = 2)
    public void hauskuh(MessageReceiver caller, String[] parameter){
        if(caller instanceof Player){
            if(parameter[1].equals("erzeugen")){
                Player spieler = caller.asPlayer();
                Location position = spieler.getLocation();            
                golem = new MeinGolem(Canary.factory().getEntityFactory().newEntityLiving(EntityType.IRONGOLEM, position), spieler);          
            }
            else if(parameter[1].equals("warten")){
                if(golem != null){
                    golem.setFolgen(false);
                    golem.setSammeln(false);
                }
            }
            else if(parameter[1].equals("folgen")){
                if(golem != null){
                    golem.setFolgen(true);
                    golem.setSammeln(false);
                }
            }
            else if(parameter[1].equals("sammeln")){
                if(parameter[2].equals("Birkenholz")){
                    golem.setZielTyp(BlockType.BirchLog);  
                }
                else if(parameter[2].equals("Erde")){
                    golem.setZielTyp(BlockType.Dirt);
                }
                else{
                    return;
                }

                golem.setFolgen(false);
                golem.setSammeln(true);
            }
        }
    }
}