import net.canarymod.api.ai.AIBase;
import net.canarymod.api.entity.living.Golem;
import net.canarymod.api.entity.living.EntityLiving;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.blocks.BlockType;
import net.canarymod.api.inventory.Item;

public class MeinGolem{
    private Golem golem;
    private Player besitzer;
    private boolean sammeln = false;
    private boolean folgen = true;
    private BlockType zielTyp; 
    private Item gegenstand = null;
    
    public MeinGolem(EntityLiving golem, Player besitzer){
        this.golem = (Golem) golem;
        this.besitzer = besitzer;

        while(this.golem.getAITaskManager().hasTask(AIBase.class)){
            this.golem.getAITaskManager().removeTask(AIBase.class);
        }

        FolgeKI fKI = new FolgeKI(this);
        this.golem.getAITaskManager().addTask(1, fKI);   

        SammelKI sKI = new SammelKI(this);
        this.golem.getAITaskManager().addTask(10, sKI);  

        this.golem.spawn();
    }

    public boolean getFolgen(){
        return folgen;
    }

    public void setFolgen(boolean folgen){
        this.folgen = folgen;
    }

    public boolean getSammeln(){
        return this.sammeln;
    }

    public void setSammeln(boolean sammeln){
        this.sammeln = sammeln;
    }

    public Golem getGolem(){
        return golem;
    }

    public Player getBesitzer(){
        return besitzer;
    }

    public BlockType getZielTyp(){
        return this.zielTyp;
    }

    public void setZielTyp(BlockType zielTyp){
        this.zielTyp = zielTyp;  
    }

    public void gegenstandNehmen(Item g){
        this.gegenstand = g;
    }

    public Item gegenstandGeben(){
        Item g = this.gegenstand;
        this.gegenstand = null;
        return g;
    }
}