import java.util.Random;
import net.canarymod.Canary;
import net.canarymod.api.ai.AIBase;
import net.canarymod.api.entity.living.Golem;
import net.canarymod.api.entity.living.EntityLiving;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.world.blocks.Block;
import net.canarymod.api.world.blocks.BlockType;
import net.canarymod.api.inventory.Item;
import net.canarymod.api.factory.ItemFactory;

public class SammelKI implements AIBase{
  private MeinGolem golem;
  private Block ziel = null;
  private static final int SUCHRADIUS = 10;
  
  
  public SammelKI(MeinGolem golem){
    this.golem = golem;
  }

  public Block blockFinden(){
    Golem golem = this.golem.getGolem();
    
    int xStart = golem.getLocation().getBlockX() - SUCHRADIUS;
    int xStop = golem.getLocation().getBlockX() + SUCHRADIUS;
    int yStart = golem.getLocation().getBlockY() - 1;
    int yStop = golem.getLocation().getBlockY() + 2;
    int zStart = golem.getLocation().getBlockZ() - SUCHRADIUS;
    int zStop = golem.getLocation().getBlockZ() + SUCHRADIUS;
            
    for(int i = yStart; i <= yStop; i++){
      for(int j = xStart; j <= xStop; j++){
        for(int k = zStart; k <= zStop; k++){
          Block b = golem.getWorld().getBlockAt(j, i, k);
          
          if(b.getType() == this.golem.getZielTyp()){
            return b;
          }                  
        }
      }
    }
    
    return null;  
  }

  @Override
  public void updateTask(){
    if(ziel == null){
      //Block suchen      
      Block neuesZiel = blockFinden();      
      
      if(neuesZiel == null){        
        //bewegen        
        Random zufallsgenerator = new Random();
        int richtung = zufallsgenerator.nextInt(4);
        
        if(this.golem.getGolem().getMotionX() == 0 && this.golem.getGolem().getMotionZ() == 0){
          this.golem.getGolem().setMotionY(0.2);
        }
        
        if(richtung == 0){
          this.golem.getGolem().setMotionX(0.2);
        }
        else if(richtung == 1){
          this.golem.getGolem().setMotionX(0.2);
        }
        else if(richtung == 2){
          this.golem.getGolem().setMotionZ(0.2);
        }
        else if(richtung == 3){
          this.golem.getGolem().setMotionZ(-0.2);
        }       
      }
      else{
        ziel = neuesZiel;
      }     
    }
    else{
      //Block abbauen
      double abstand = this.golem.getGolem().getLocation().getDistance(ziel.getLocation());
      
      if(Math.abs(abstand) > 2){
        this.golem.getGolem().moveEntityToXYZ(ziel.getLocation().getX(), ziel.getLocation().getY(), ziel.getLocation().getZ(), 1.0f);
      }
      else{
        ItemFactory gegenstaende = Canary.factory().getItemFactory();
        Item gesammelt = gegenstaende.newItem(ziel.getIdDropped());
        this.ziel.setType(BlockType.Air);
        this.ziel.update();
        this.golem.gegenstandNehmen(gesammelt);
        this.golem.setSammeln(false);
        this.golem.setFolgen(true);
      }
    }
  }
  
  @Override
  public void resetTask(){
    ziel = null;
  }
    
  @Override
  public void startExecuting(){
  }
  
  @Override
  public boolean isContinuous(){
    return true;
  }
  
  @Override
  public boolean continueExecuting(){
    return golem.getSammeln();
  }
  
  @Override
  public boolean shouldExecute(){
    return golem.getSammeln();  
  }
}