import net.canarymod.Canary;
import net.canarymod.plugin.Plugin;
import net.canarymod.logger.Logman;
import net.canarymod.commandsys.Command;
import net.canarymod.commandsys.CommandListener;
import net.canarymod.chat.MessageReceiver;
import net.canarymod.api.entity.EntityType;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.entity.living.EntityLiving;
import net.canarymod.api.ai.AIBase;

public class HauskuhPlugin extends Plugin implements CommandListener{
    @Override
    public boolean enable() {
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        return true;
    }

    @Override
    public void disable() {
    }

    @Command(aliases = {"kuh"},
             description = "Erzeugt eine Hauskuh",
             permissions = {""},
             toolTip = "/kuh")
    public void hauskuh(MessageReceiver caller, String[] parameter){
        if(caller instanceof Player){
            Player spieler = caller.asPlayer();
            Location position = spieler.getLocation();
            
            EntityLiving kuh = Canary.factory().getEntityFactory().newEntityLiving(EntityType.COW, position);
            while(kuh.getAITaskManager().hasTask(AIBase.class)){
                kuh.getAITaskManager().removeTask(AIBase.class);
            }
        
            KuhI ki = new KuhI(spieler, kuh);       
            kuh.getAITaskManager().addTask(100, ki);

            kuh.spawn();
        }
    }
}