import net.canarymod.plugin.Plugin;
import net.canarymod.logger.Logman;
import net.canarymod.Canary;
import net.canarymod.commandsys.*;
import net.canarymod.chat.MessageReceiver;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.position.Location;
import net.canarymod.api.world.blocks.BlockType;
import net.canarymod.api.world.World;

public class MauerPlugin extends Plugin implements CommandListener {
    @Override
    public boolean enable() {
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        return true;
    }
    
    @Override
    public void disable() {
    }
    
    @Command(aliases = {"mauer"},
             description = "Platziert eine Mauer vor dem Spieler",
             permissions = {""},
             toolTip = "/mauer")
    public void mauerPlatzieren(MessageReceiver caller, String[] parameter){
        Player spieler = (Player) caller;
        
        Location position = spieler.getLocation();
        World welt = spieler.getWorld();
        
        double yStart = position.getY();
        double zStart = position.getZ();
        
        position.setX(position.getX() + 2);
        
        for(int y = 0; y < 10; y++){
            position.setY(yStart + y);
            
            for(int z = 0; z < 20; z++){
                position.setZ(zStart + z);
                welt.setBlockAt(position, BlockType.GoldBlock);
            }
        }
    }
}