import net.canarymod.plugin.Plugin;
import net.canarymod.logger.Logman;
import net.canarymod.Canary;
import net.canarymod.commandsys.*;
import net.canarymod.chat.MessageReceiver;
import net.canarymod.api.entity.living.humanoid.Player;
import net.canarymod.api.world.blocks.BlockType;

public class BauenPlugin extends Plugin implements CommandListener {
    @Override
    public boolean enable() {
        try{
            Canary.commands().registerCommands(this, this, false);
        }
        catch(Exception e){
            getLogman().error("Befehl konnte nicht registriert werden");
        }
        return true;
    }
    
    @Override
    public void disable() {
    }
    
    @Command(aliases = {"bauen"},
             description = "Baut eine Mauer oder einen Quader",
             permissions = {""},
             toolTip = "/bauen <hoehe> <breite> (<tiefe>)",
             min = 3)
    public void bauen(MessageReceiver caller, String[] parameter){
        if(caller instanceof Player){
            Viereckig v;
            
            int hoehe = Integer.valueOf(parameter[1]);
            int breite = Integer.valueOf(parameter[2]);
            Player spieler = (Player) caller;
            
            if(parameter.length < 4){
                v = new Mauer(breite, hoehe, BlockType.GoldBlock);
            }
            else{
                int tiefe = Integer.valueOf(parameter[3]);
                v = new Quader(hoehe, breite, tiefe, BlockType.GoldBlock);
            }
            
            v.bauen(spieler);
        }
        else{
            getLogman().info("Dieser Befehl kann nur von Spielern ausgefhrt werden.");
        }
    }
}